io.undertow.protocols.http2

## Class HpackDecoder

- java.lang.Object
- - io.undertow.protocols.http2.HpackDecoder

    public class HpackDecoder
    extends Object

A decoder for HPACK.

Author:
  Stuart Douglas

### Nested Class Summary

Nested Classes
`static interface` `HpackDecoder.HeaderEmitter`

### Constructor Summary

Constructors
Constructor and Description
`HpackDecoder()`
`HpackDecoder(int maxAllowedMemorySize)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `decode(ByteBuffer buffer, boolean moreData)` Decodes the provided frame data.
`HpackDecoder.HeaderEmitter` `getHeaderEmitter()`
`void` `setHeaderEmitter(HpackDecoder.HeaderEmitter headerEmitter)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### HpackDecoder

    public HpackDecoder(int maxAllowedMemorySize)

#### HpackDecoder

    public HpackDecoder()

### Method Detail

#### decode

    public void decode(ByteBuffer buffer,
                       boolean moreData)
                throws HpackException

Decodes the provided frame data. If this method leaves data in the buffer then this buffer should be compacted so this data is preserved, unless there is no more data in which case this should be considered a protocol error.

Parameters:
  `buffer` - The buffer
Throws:
  `HpackException`

#### getHeaderEmitter

    public HpackDecoder.HeaderEmitter getHeaderEmitter()

#### setHeaderEmitter

    public void setHeaderEmitter(HpackDecoder.HeaderEmitter headerEmitter)